﻿//#define OPENGLSTUFF

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using xNL_Analyser;

namespace GraphTest2 {
   public partial class Form1 : Form {
      public Form1()
      {
         InitializeComponent();

#if OPENGLSTUFF
			this.teeOpenGL1 = new Steema.TeeChart.Drawing.GL.TeeOpenGL();
			this.teeOpenGL1.Active = true;
			this.teeOpenGL1.Chart = this.tChart1;
			this.teeOpenGL1.TextureQuality = false;
			this.teeOpenGL1.AmbientLight = 100;
			tChart1.Aspect.Rotation = 0;
			tChart1.Aspect.Elevation = 0;
			tChart1.Aspect.Perspective = 0;
			tChart1.Aspect.View3D = true;
#endif

			//tChart1.Series.RemoveAllSeries();
			//colorGrid1 = new Steema.TeeChart.Styles.ColorGrid(tChart1.Chart);
			//colorGrid1.Pen.Visible = false;

			//dummyGrid = new Steema.TeeChart.Styles.ColorGrid(tChart1.Chart);

			chartController1.Chart = tChart1;

         InitializeChart();
      }

      private ColourPalette colourPalette;
      private double colourScale;
		private Steema.TeeChart.Drawing.GL.TeeOpenGL teeOpenGL1;

      private void InitializeChart()
      {
			this.tChart1.Series.Clear();

			colorGrid1 = new Steema.TeeChart.Styles.ColorGrid(tChart1.Chart);
			dummyGrid = new Steema.TeeChart.Styles.ColorGrid(tChart1.Chart);

			colorGrid1.Pen.Visible = false;
			colorGrid1.VertAxis = Steema.TeeChart.Styles.VerticalAxis.Right;
			colourPalette = new ColourPalette();
         colourPalette.Load("cmap.xml");

         double maxrate = 255;
         double minrate = 0;

         if (maxrate != minrate) {
            colourScale = colourPalette.Colours.Count / (maxrate - minrate);
         } else {
            colourScale = 0; 
         }

			dummyGrid.Title = "DummyGrid";
			dummyGrid.Pen.Visible = false;
			dummyGrid.VertAxis = Steema.TeeChart.Styles.VerticalAxis.Left;

			dummyGrid.CenteredPoints = true;
			dummyGrid.IrregularGrid = true;

			double numrecs = 5; //(double)numericUpDown1.Value;
			for (int i = 0; i < 100; i++) {
				int j;
				for (j = 0; j < numrecs; j++) {
					dummyGrid.Add((double)i, (double)((j * j) % 255), (double)(1 + j * 1.1));
				}
			}


         // Configure ColorGrid's palette
         colorGrid1.PaletteSteps = colourPalette.Colours.Count;
         colorGrid1.ClearPalette();
         for (int colouri = 0; colouri < colourPalette.Colours.Count; colouri++) {
            colorGrid1.AddPalette(minrate + colouri / colourScale,
                     colourPalette.Colours[colouri]);
         }
         colorGrid1.UseColorRange = false;
         colorGrid1.UsePalette = true;

         colorGrid1.CenteredPoints = true;
			colorGrid1.IrregularGrid = false;

			colorGrid1.Clear();
			for (int i = 0; i < 1024; i++) {
				int j;
				double val = 5;//(double)numericUpDown1.Value;
				for (j = 0; j < val; j++) {
					colorGrid1.Add(i, ((i+1) * (j+1)) % 255, j);
				}
			}
      }

      private void button1_Click(object sender, EventArgs e)
      {
			tChart1.Aspect.Rotation = tChart1.Aspect.Rotation + 1;
			InitializeChart();
      }

   }
}
